apiVersion: tekton.dev/v1beta1
kind: ClusterTask
metadata:
  name: clear-cache
  labels:
    app: drupal
  annotations:
    argocd.argoproj.io/compare-options: IgnoreExtraneous
spec:
  params:
    - name: drupalSite
      type: string
      description: The name of the drupal site
    - name: namespace
      type: string
      description: The namespace of the drupal site
  steps:
    - name: clear-cache
      image: {{ .Values.image }}
      imagePullPolicy: Always
      command:
        - /bin/sh
        - '-c'
      args:
      - |-
        echo "--------------------------- Clear cache ---------------------------"
        echo "Drupal site name: $(params.drupalSite)"
        export DATE=$(date +%F-%H-%M)
        export TASK=clear-cache-$DATE
        export OPERATION="clear-cache"
        export DRUPALSITE=$(params.drupalSite)
        export NAMESPACE=$(params.namespace)
        export SERVING_POD_IMAGE=$(oc get -n "$NAMESPACE" "drupalsite/$DRUPALSITE" -o=jsonpath='{.status.servingPodImage}')
        envsubst < /tekton-task-templates/drupal_operation_job.yaml | oc create -n "$NAMESPACE" -f -
        oc wait --timeout=1h --for=condition=complete "job/$TASK-$DRUPALSITE" -n "$NAMESPACE"
        jobStatus=$(oc get "job/$TASK-$DRUPALSITE" -o=jsonpath='{.status.conditions[*].type}' | grep -i -E 'failed|complete' || echo "Failed")
        echo "Job status: $jobStatus"
        echo "Job logs:"
        oc logs "job/$TASK-$DRUPALSITE" -n "$NAMESPACE"
        echo "Cleaning up Jobs"
        oc delete -n "$NAMESPACE" "job/$TASK-$DRUPALSITE"
